import zipfile
import json
import os
import shutil

def patch(json_dump):
    info = json.loads(json_dump)
    info["factorio_version"] = "0.14"
    return json.dumps(info,indent=4).encode()

for files in os.listdir():
    for file in files:
        ffile =  file
        if ffile.endswith(".zip"):
            ffile2 = ffile+".backup"
            shutil.move(ffile,ffile2)
            done = False
            with zipfile.ZipFile(ffile,"w", zipfile.ZIP_DEFLATED) as out:
                with zipfile.ZipFile(ffile2, "r") as z:
                    files = z.namelist()
                    for file in files:
                        if file.endswith("info.json"):
                            if not done:
                                info = z.read(file).decode()
                                info = patch(info)
                                out.writestr(file,info)
                                done = True
                        else:
                            out.writestr(file, z.read(file))

